#ifndef _SHADE_H
#define _SHADE_H
#include "matrix.h"


int nverts; /* Number of vertices in world */
int npolys; /* Number of polygons */

typedef struct{            /* A POLYGON VERTEX */
  double sx, sy, sz, sw;   /* sky space position */
  double x, y, z;          /* world space position */
  vector normal;           /* world space normal vector */
  double r, g, b;          /* (red,green,blue) color */
} Poly_vert;

Poly_vert* vlist; /* array of vertices */

typedef struct{
  int v[3];          /* vertices */
  unsigned long mask;     /* interpolation mask for vertex elems */
  int n;                    /* number of sides */
  vector normal;          /* normal (used for back face culling) */
}Triangle;

Triangle* plist; /* array of polygons (with references to vertices) */
  
typedef struct {		/* WINDOW: A DISCRETE 2-D RECTANGLE */
  int x0, z0;			/* xmin and ymin */
  int x1, z1;			/* xmax and ymax (inclusive) */
} Window;

#define MAXLINE 80
#define NORTH 2     /* z coordinate */
#define UP 1   /* y coordinate */
#define EAST 0    /* x coordinate */

#ifdef ANSI
extern void myerror(int errorno);
#else 
extern void myerror();
#endif

typedef struct{
  double y;
  int vertex;
}Y_struct;
Y_struct** Ybuffer; 
int xsize, zsize;

void	poly_scan();
#endif














